#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "dSFMT.h"

#define N 1000000		//10^6
dsfmt_t dsfmt1;

int main(int argc, char *argv[]){
	dsfmt_init_gen_rand(&dsfmt1,1);
	
	int i,j,k;
	//time-series
	double *ts;
	ts=(double *)calloc(N, sizeof(double));
	double *dif;
	dif=(double *)calloc(N, sizeof(double));
	//runs test
	int r,p,n,all;
	double E,V,Z;
	//file
	FILE *fp;
	if( (fp=fopen("problem3_6_3.dat","w")) ==NULL){
		printf("FILE Error\n");
		exit(1);
	}
	
	
	//ts : diff time-series of garch or RW
	for(i=0 ; i<N ; i++ ){
		ts[i]=dsfmt_genrand_close_open(&dsfmt1)-0.5;
	}
	
	//k : time-width  : exponential
	for(k=1 ; k<N ; k=k*2 ){
	
		//To use the eq() , int(N/k) needs to be larger than 20
		if( (int)(N/k)>20 ){
			
			for(i=0;i<(int)(N/k);i++){
				for(j=k*i;j<k*(i+1);j++){	//Ex.	k=3 : ts[i]=0.24 , ts[i+1]=-1.20 , ts[i+2]=0.88
					dif[i]+=ts[j];			//		dif[i] : -0.08
				}
			
				if(dif[i]>0.0){
					dif[i]=1.0;
				}else{
					dif[i]=-1.0;
				}
			}
	
	
			//runs test
			r=1;
			p=0,n=0,all=0;
			
			for(i=0;i<(int)(N/k);i++){
				if(dif[i]*dif[i-1]<0.0){
					r+=1;	//the num of runs
				}
				
				if(dif[i]>0.0){
					p+=1;	//the num of plus
				}else{
					n+=1;	//the num of minus
				}
				all+=1;		//the total num
			}
	
			//Average , Standard Deviation , Z-value
			E=2.0*p*n/all+1.0;
			V=sqrt( 2.0*p*n*(2.0*p*n-all)/(all-1.0))/all;
			Z=((double)r-E)/V;
			fprintf( fp , "%d	%f\n", k , Z);
			
		}//if
	}//k
	
	fclose(fp);
	free(ts);
	free(dif);
	return 0;
}
